unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqlite3conn, sqldb, db, FileUtil, Forms, Controls,
  Graphics, Dialogs, DbCtrls, DBGrids;

type

  { TForm1 }

  TForm1 = class(TForm)
    DsArticles: TDataSource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    SQLite3Connection1: TSQLite3Connection;
    QryArticles: TSQLQuery;
    SQLTransaction1: TSQLTransaction;
    procedure FormCreate(Sender: TObject);
  private
    procedure CreateTables;
    procedure PopulateTables;

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

const
  DB_NAME = 'test.sqlite';

function RandomString(Len: Integer): String;
var
  j: Integer;
begin
  SetLength(Result, Len);
  for j:=1 to Len do
    Result[j] := char(Random(26) + ord('A'));
end;
  
{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  //if FileExists(DB_NAME) then DeleteFile(DB_NAME);

  SQLite3Connection1.DatabaseName := DB_NAME;
  if not FileExists(DB_NAME) then begin
    CreateTables;
    PopulateTables;
  end;
  SQLite3Connection1.Connected := true;
  QryArticles.SQL.Add('SELECT * FROM Articles');
  QryArticles.Open;
end;

procedure TForm1.CreateTables;
begin
  SQLTransaction1.StartTransaction;
  SQLite3Connection1.Connected := true;
  SQLite3Connection1.ExecuteDirect('CREATE TABLE Articles (' +
    'ArticleID INTEGER UNIQUE NOT NULL, '+
    'ArticleName VARCHAR(50), '+
    'Price FLOAT)');
  SQLTransaction1.Commit;
  SQLite3Connection1.Connected := false;
end;

procedure TForm1.PopulateTables;
const
  N = 1000*1000;
var
  i, j: Integer;
  id: Integer;
  m: Integer;
  s: String;
  p: Double;
  fs: TFormatSettings;
  dt: TDate;
  t: TDateTime;
begin
  t := now;
  SQLTransaction1.StartTransaction;
  fs := FormatSettings;
  fs.DecimalSeparator := '.';
  for i:=0 to N-1 do begin
    id := i; 
    p := Random * 1000;
    s := RandomString(3 + Random(5));
    SQLite3Connection1.ExecuteDirect(Format(
      'INSERT INTO Articles (ArticleID, ArticleName, Price) VALUES (%d, "%s", %.2f)', [
      id, s,  p
    ], fs));
  end;
  SQLTransaction1.Commit;
  QryArticles.EnableControls;
  Caption := 'Population time: ' + FormatDateTime('s.zzz', now-t) + ' sec';
end;

end.

